{% extends "consensus_base/base_dashboard_alt.html" %}
{% load i18n %}
{% load sekizai_tags %}
{% load consensus %}
{% block title %}Consensus - Questions{% endblock %}

{% block main-h1 %}
{% trans 'Polls:' %} {{ poll.title }}
- [<a class="btn-sm btn-link" href="{% url 'consensus_base:poll' poll.slug %}">{% trans 'view' %}</a>]
- [<a class="btn-sm btn-link" href="{% url 'consensus_base:poll_settings' poll.slug %}">{% trans 'settings' %}</a>]
{% endblock main-h1 %}

{% block main %}
<!-- Begin web poll section -->
<div id="poll"></div>
<!-- End web poll section -->

                 
{% addtoblock "js" %}
    var poll_uuid = "{{ poll.uuid.hex }}";
    var json_poll_status = "{% url 'consensus_base:json_poll_status' poll.uuid.hex %}";
    var json_choice = "{% url 'consensus_base:json_choice' %}";
    var json_question = "{% url 'consensus_base:json_question' %}";

    function render_choices (question) {
        var question_uuid = question.uuid;
        $( "#question-choices-" + question_uuid ).append( '<ul id="ul-question-choices-' + question_uuid + '"></ul>' );
        for (var choice in question.choices) {
            render_choice (question, choice);
        };
        $( "#question-choices-" + question_uuid ).append(
            '<button class="choice-add btn btn-default col-12 mt-1" type="button" id="choice-add-' + question_uuid  + '">Add choice</button>'
        );
        $( "#choice-add-" + question_uuid ).click(add_choice);
    }

    function render_choice (question, choice) {
        if (question.choices.hasOwnProperty(choice)) {           
            var question_uuid = question.uuid;
            var choice_group = 'question-choices-group-' + question_uuid;
            var choice_id = 'question-choices-group-' + question_uuid + '-' + choice;
            $( "#question-choices-" + question_uuid).append(
                '<li class="list-group-item" id="li-' + choice_id + ' ">'
                + '<div class="form-group row">'
                + '<label class="col-form-label col-12 col-md-2 col-xl-1">Choice:</label>'
                + '<input class="question-choice form-control input-sm col-12 col-md-8 col-xl-10" type="text" id="' + choice_id + '" value="' + question.choices[choice].text + '"/>' 
                + '<button class="question-choice-delete btn btn-danger col-12 col-md-2 col-xl-1" id="delete-' + choice_id + '" type="button" tabindex="-1">Delete</button>'
                + '</div>'
                + '</li>');
            $( "#" + choice_id ).change(update_choice);
            $( "#delete-" + choice_id ).click(delete_choice);
        }
    }


    function click_handlers(){
        $( ".question-add" ).click(add_question);
    }

    function render_poll(data){
        console.log("Loaded poll status");
        console.log(data);
        render_questions(data.questions);
        click_handlers();
    }


    function render_questions(questions){
        $("#poll").append('<ul id="questions" class="list-group"></ul>');
        for ( var q in questions) { 
            render_question(questions[q]);
        };
        $( "#poll" ).append(
            '<button class="question-add btn btn-secondary col-12 mt-2" type="button">Add new question</button>'
        );
    }


    function render_question(question){
        var question_uuid = question.uuid;

        if ($('#question-' + question_uuid ).length > 0)
        {
            $('#question-' + question_uuid ).empty();
        }
        else {
            $( "#questions" ).append(
                '<li id="question-' + question_uuid + '" class="list-group-item"></>'
            )
        }
        $( "#question-" + question_uuid ).append(
            '<div class="form-group row">'
            + '<label class="col-12 col-md-2 col-xl-1 col-form-label h6">Question:</label>'
            + '<input class="col-12 col-md-10 col-xl-11 question-title form-control input-sm" type="text" id="question-title-' + question_uuid + '" value="' + question.text + '"/>' 
            + '</div>'
            + '<div class="form-group row">'
            + '    <div class="col-4 col-md-2">Checks:</div>'
            + '    <div class="col-5 col-md-5">'
            + '        <div class="form-check">'
            + '            <input class="form-check-input" type="checkbox" id="question-mandatory-check-' + question_uuid + '">'
            + '            <label class="form-check-label" for="question-mandatory-check-' + question_uuid + '">'
            + '            Mandatory'
            + '            </label>'
            + '        </div>'
            + '    </div>'
            + '    <div class="col-3 col-md-5">'
            + '        <div class="form-check">'
            + '            <input class="form-check-input" type="checkbox" id="question-hide-check-' + question_uuid + '">'
            + '            <label class="form-check-label" for="question-hide-check-' + question_uuid + '">'
            + '            Hide'
            + '            </label>'
            + '        </div>'
            + '    </div>'
            + '</div>'
            + '<div id="question-choices-' + question_uuid + '">'
            + '</div>'
            + '<button class="question-title-delete btn btn-danger col-12 mt-1" id="delete-' + question_uuid + '" type="button" tabindex="-1">Delete question</button>'
        );
        $( "#question-mandatory-check-" + question_uuid ).click(update_question_mandatory);
        $( "#question-mandatory-check-" + question_uuid ).prop('checked', question.mandatory);
        $( "#question-hide-check-" + question_uuid ).click(update_question_hide);
        $( "#question-hide-check-" + question_uuid ).prop('checked', question.hide);
        $( "#question-title-" + question_uuid ).change(update_question_name);
        $( "#delete-" + question_uuid ).click(delete_question);
        render_choices(question);
    }

    function add_choice(e) {
        var question_uuid = e.target.id.replace('choice-add-','');
        console.log("Add choice in question" + question_uuid);
        $.ajax({
            type:"POST",
            url: json_choice,
            data: {
                action: 'create',
                question: question_uuid
            },
            dataType: 'json',
            success: function (data) {
                render_question(data.value);
                $('#question-choices-group-' + data.value.uuid + '-' + data.value.choices.length).focus();
                show_save_message()
            }
        });
    }

    function add_question() {
        console.log("Add question in poll" + poll_uuid);
        $.ajax({
            type:"POST",
            url: json_question,
            data: {
                action: 'create',
                poll: poll_uuid,
                values: JSON.stringify({
                    "hide": 1,
                    "mandatory": true
                })
            },
            dataType: 'json',
            success: function (data) {
                render_question(data.value);
                show_save_message()
            }
        });
    }

    function load_json_poll_status() {
        $.ajax({
            url: json_poll_status,
            success: render_poll
        });
    }

    function update_choice(e) {
        var choice_uuid = e.target.id.replace('question-choices-group-','').split('-');
        var choice_value = e.currentTarget.value;
        console.log("Change in choice " + choice_uuid + ": " + choice_value);
        $.ajax({
            type:"POST",
            url: json_choice,
            data: {
                action: 'update',
                question: choice_uuid[0],
                choice: choice_uuid[1],
                value: choice_value,
            },
            dataType: 'json',
            success: function (data) {
                console.log("Choice updated");
                console.log(data);
                show_save_message()
            }
        });
    }

    function update_question_name(e) {
        var question_uuid = e.target.id.replace('question-title-','');
        var value = e.currentTarget.value;
        console.log("Change title in question " + question_uuid + ": " + value);
        $.ajax({
            type:"POST",
            url: json_question,
            data: {
                action: 'update',
                question: question_uuid,
                value: value,
                values: JSON.stringify({
                    "question": value
                })
            },
            dataType: 'json',
            success: function (data) {
                console.log("Question name updated");
                console.log(data);
                render_question(data.value);
                show_save_message()
            }
        });
    }

    function update_question_hide(e) {
        var question_uuid = e.target.id.replace('question-hide-check-','');
        var hide = $('#question-hide-check-' + question_uuid).is(":checked");
        console.log("Change hide flag in question " + question_uuid + ": " + hide);
        $.ajax({
            type:"POST",
            url: json_question,
            data: {
                action: 'update',
                question: question_uuid,
                values: JSON.stringify({
                    "hide": hide
                })
            },
            dataType: 'json',
            success: function (data) {
                console.log("Question hide property updated");
                console.log(data);
                render_question(data.value);
                show_save_message()
            }
        });
    }

    function update_question_mandatory(e) {
        var question_uuid = e.target.id.replace('question-mandatory-check-','');
        var mandatory = $('#question-mandatory-check-' + question_uuid).is(":checked");
        console.log("Change mandatory flag in question " + question_uuid + ": " + mandatory);
        $.ajax({
            type:"POST",
            url: json_question,
            data: {
                action: 'update',
                question: question_uuid,
                values: JSON.stringify({
                    "mandatory": mandatory
                })
            },
            dataType: 'json',
            success: function (data) {
                console.log("Question mandatory property updated");
                console.log(data);
                render_question(data.value);
                show_save_message()
            }
        });
    }

    function delete_choice(e) {
        var choice_uuid = e.target.id.replace('delete-question-choices-group-','').split('-');
        console.log("Delete choice " + choice_uuid);
        $.ajax({
            type:"POST",
            url: json_choice,
            data: {
                action: 'delete',
                question: choice_uuid[0],
                choice: choice_uuid[1],
            },
            dataType: 'json',
            success: function (data) {
                console.log("Choice deleted");
                console.log(data);
                render_question(data.value);
                show_save_message()
            }
        });
    }
 
    function delete_question(e) {
        var uuid = e.target.id.replace('delete-','');
        console.log("Delete question " + uuid);
        $.ajax({
            type:"POST",
            url: json_question,
            data: {
                action: 'delete',
                question: uuid,
            },
            dataType: 'json',
            success: function (data) {
                if (data['return'] == 0) {
                    console.log("Question deleted");
                    console.log(data);
                    console.log("#question-" + data['value']['uuid']);
                    $("#question-" + data['value']['uuid']).remove();
                    show_save_message()
                }
            }
        });
    }
    
    $(document).ready(function(){
        load_json_poll_status();

    })
{% endaddtoblock %}
{% endblock main %}
